#!/bin/sh
ndir=`pwd`
fdir=$ndir/data
kdir=$ndir/aluba
tdir=$ndir/tmp
tfile=account.tar.gz
kfile=aluba.tar.gz

# check file a
echo "1.check file..."
echo ""

if [ -a /tmp/group.temp ]; then
	rm -f /tmp/group.temp
fi

if [ -a /tmp/group_mem.temp ]; then
	rm -f /tmp/group_mem.temp
fi

if [ -a /tmp/users.temp ]; then
	rm -f /tmp/users.temp
fi

if [ -a /tmp/users.csv ]; then
	rm -f /tmp/users.csv
fi

if [ -a /tmp/group.csv ]; then
	rm -f /tmp/group.csv
fi

if [ -a $tfile ]; then
	rm -f $tfile
fi

if [ -d $fdir ]; then
	rm -rf $fdir
fi

if [ ! -d $fdir ]; then
	mkdir $fdir
fi

if [ ! -d $tdir ]; then
	mkdir $tdir
fi

echo "2.transfer temp-file from mysql..."
echo ""
mysql -uroot < tran.mysql

echo "3.make all account data file..."
echo ""
# X user ഫɤαKXഫ
# NsդgidOŦrꪺאּ 1001
sed 's/,\\N,/,1001,/g' /tmp/users.temp > $tdir/users.temp1
# NusernameOƦr, אּ u+username
sed 's/\(^[0-9]*\),\([0-9][0-9]*\),\([0-9][0-9]*\),\(.*\)/u\1,\2,\3,\4/g' $tdir/users.temp1 > $tdir/users.temp2
# NusernameO媺, אּ chu+uid
sed 's/\(^.*[^0-9a-zA-Z][^0-9a-zA-Z].*\),\([0-9][0-9]*\),\([0-9][0-9]*\),\(.*\)/chu\2,\2,\3,\4/g' $tdir/users.temp2 > $tdir/users.temp3
cat $tdir/users.temp3 | $ndir/mkusers.sh > $fdir/users.list
cat $tdir/users.temp3 | $ndir/mkpasswd.sh > $fdir/passwd.list
cat $tdir/users.temp3 | $ndir/mkmail2000.sh > $fdir/mail2000.list
cat $tdir/users.temp3 | $ndir/mkmail2000.sh > $kdir/mail2000.list

# X user Ӫ
sed 's/,\\N,/,1001,/g' /tmp/users.csv > $tdir/users.csv1
sed 's/\(^[0-9].*\),\([0-9]*\),\([0-9][0-9]*,[0-9][0-9]*\),\(.*,.*$\)/\1,u\2,\3,\4/g' $tdir/users.csv1 > $tdir/users.csv2
sed 's/\(^.*[^0-9a-zA-Z][^0-9a-zA-Z].*\),\(.*[^0-9a-zA-Z][^0-9a-zA-Z].*\),\([0-9][0-9]*,[0-9][0-9]*\),\(.*,.*$\)/\1,chu\3,\3,\4/g' $tdir/users.csv2 >> $tdir/users.csv3
printf "lb , קLb , uid , gid , firstname , lastname , password\n" > $fdir/users.csv
sed 's/\(^.*\),\(.*\),\([0-9][0-9]*,[0-9][0-9]*\),\(.*,.*\)/\1,\2,\3,\4,web\2/g' $tdir/users.csv3 >> $fdir/users.csv

# X group Ӫ
# printf "gid , old-groupname , new-groupname\n" > $tdir/group.csv1
sed 's/\(^[0-9][0-9]*\),\([0-9]*\),\([0-9]*\)/\1,\2,g\3/g' /tmp/group.csv > $tdir/group.csv1
printf "gid , lgroupW , קLgroupW\n" > $fdir/group.csv
sed 's/\(^[0-9][0-9]*\),\(.*[^0-9a-zA-Z][^0-9a-zA-Z].*\),\(.*[^0-9a-zA-Z][^0-9a-zA-Z].*\)/\1,\2,chg\1/g' $tdir/group.csv1 >>  $fdir/group.csv

# X group  gshadow 
cat /tmp/group.temp | $ndir/mkgroupsh.sh > $tdir/mkgroup.sh
chmod +x $tdir/mkgroup.sh
$tdir/mkgroup.sh > $tdir/group.temp
# קƦrgroup name, אּ g+Ʀrgroup name
sed 's/\(^[0-9]*:x:\)/g\1/g' $tdir/group.temp > $tdir/group.temp1
# ק大group name, אּ chg+gid 
sed 's/\(^.*[^0-9a-zA-Z][^0-9a-zA-Z].*\):x:\([0-9][0-9]*\):/chg\2:x:\2:/g' $tdir/group.temp1 > $tdir/group.temp2
# C̫@ӳr
sed 's/,$//g' $tdir/group.temp2 > $fdir/group.list
# N group ন gshadow
sed 's/:x:[0-9][0-9]*:/:!::/g' $fdir/group.list > $fdir/gshadow.list

cp -a $ndir/ins_linux_acc.sh $fdir/install.sh

echo "4.compress all account data to $tfile ..."
echo ""
cd $ndir
tar czvf $tfile data > /dev/null
tar czvf $kfile aluba > /dev/null

echo "5.remove all temp-file..."
echo ""
rm -f /tmp/*.temp
rm -f /tmp/*.csv
rm -rf $fdir
rm -rf $tdir

echo "6.finish!"
echo ""
echo ""
echo "ALL account is in account.tar.gz and aluba.tar.gz file."
echo ""
echo "account.tar.gz is for Linux or Unix-Like system's account."
echo "aluba.tar.gz is for mail2000 webmail system account."
echo ""
echo ""
